/*
 * Copyright (C) 2005-2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.dao.hibernate;

import java.util.List;

import org.hibernate.LockMode;
import org.hibernate.Query;
import org.springframework.dao.DataAccessException;
import org.springframework.orm.ObjectRetrievalFailureException;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import jp.sourceforge.livez.dao.Imode;
import jp.sourceforge.livez.dao.ImodeDAO;

/**
 * ImodeDAO  Hibernate 3 ŎNXłB
 * 
 * @author V _
 */
public final class ImodeDaoImpl extends HibernateDaoSupport implements ImodeDAO {

	/**
	 * ftHgRXgN^łB
	 */
	public ImodeDaoImpl() {}

	/*
	 * @see jp.sourceforge.livez.dao.ImodeDAO#loadAll()
	 */
	@SuppressWarnings("unchecked")
	public List<Imode> loadAll() throws DataAccessException {
		HibernateTemplate template = getHibernateTemplate();
		return template.loadAll(Imode.class);
	}

	/*
	 * @see jp.sourceforge.livez.dao.ImodeDAO#load(java.lang.String)
	 */
	@SuppressWarnings("unchecked")
	public Imode load(final String name) throws DataAccessException {
		HibernateTemplate template = getHibernateTemplate();
		try {
			return (Imode) template.load(Imode.class, name);
		} catch (ObjectRetrievalFailureException e) {
			return null;
		}
	}

	/*
	 * @see jp.sourceforge.livez.dao.ImodeDAO#save(jp.sourceforge.livez.dao.Imode)
	 */
	public void save(final Imode imode) throws DataAccessException {
		HibernateTemplate template = getHibernateTemplate();
		template.save(imode);
	}

	/*
	 * @see jp.sourceforge.livez.dao.ImodeDAO#update(jp.sourceforge.livez.dao.Imode, java.lang.String)
	 */
	public void update(final Imode imode, final String name) throws DataAccessException {
/*
		delete(name);
		this.getSession().flush();
		save(imode);

		if (!name.equals(imode.getName())) {
			Query query = getSession().createQuery("UPDATE Imode SET name = ? WHERE name = ?");
			query.setString(0, imode.getName());
			query.setString(1, name);
			query.executeUpdate();
		}
*/

		HibernateTemplate template = getHibernateTemplate();
		template.update(imode, LockMode.UPGRADE_NOWAIT);
	}

	/*
	 * @see jp.sourceforge.livez.dao.ImodeDAO#delete(java.lang.String)
	 */
	public void delete(final String name) throws DataAccessException {
		HibernateTemplate template = getHibernateTemplate();
		Imode imode = (Imode) template.load(Imode.class, name);
		template.delete(imode, LockMode.UPGRADE_NOWAIT);
	}

}
