/*
 * Copyright (C) 2005-2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.dao.ibatis;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.springframework.dao.DataAccessException;
import org.springframework.orm.ibatis.SqlMapClientTemplate;
import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;

import jp.sourceforge.livez.dao.Imode;
import jp.sourceforge.livez.dao.ImodeDecomail;
import jp.sourceforge.livez.dao.ImodeFlash;
import jp.sourceforge.livez.dao.ImodeFrame;
import jp.sourceforge.livez.dao.ImodeIappli;
import jp.sourceforge.livez.dao.ImodeSubscreen;

/**
 * ImodeDAO  iBATIS ŎNXłB
 * 
 * @author V _
 */
public final class ImodeDaoImpl extends SqlMapClientDaoSupport implements jp.sourceforge.livez.dao.ImodeDAO {

	/**
	 * ftHgRXgN^łB
	 */
	public ImodeDaoImpl() {}

	/*
	 * @see jp.sourceforge.livez.dao.ImodeDAO#loadAll()
	 */
	@SuppressWarnings("unchecked")
	public List<Imode> loadAll() throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		List list = template.queryForList("livez.listImode", null);

		for (int i = 0; i < list.size(); i++)
			loadChild((Imode)list.get(i));

		return list;
	}

	/*
	 * @see jp.sourceforge.livez.dao.ImodeDAO#load(java.lang.String)
	 */
	@SuppressWarnings("unchecked")
	public Imode load(final String name) throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		Imode imode = (Imode) template.queryForObject("livez.getImode", name);

		if (imode != null)
			loadChild(imode);

		return imode;
	}

	@SuppressWarnings("unchecked")
	private void loadChild(final Imode imode) throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		String name = imode.getName();

		imode.setSubscreen((ImodeSubscreen) template.queryForObject("livez.getImodeSubscreen", name));
		imode.setIappli((ImodeIappli) template.queryForObject("livez.getImodeIappli", name));
		imode.setFlash((ImodeFlash) template.queryForObject("livez.getImodeFlash", name));
		imode.setDecomail((ImodeDecomail) template.queryForObject("livez.getImodeDecomail", name));
		imode.setFrames(new HashSet(template.queryForList("livez.getImodeFrame", name)));
	}

	/*
	 * @see jp.sourceforge.livez.dao.ImodeDAO#save(jp.sourceforge.livez.dao.Imode)
	 */
	public void save(final Imode imode) throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		template.insert("livez.saveImode", imode);

		if (imode.getSubscreen() != null)
			template.insert("livez.saveImodeSubScreen", imode.getSubscreen());
		if (imode.getIappli() != null)
			template.insert("livez.saveImodeIappli", imode.getIappli());
		if (imode.getFlash() != null)
			template.insert("livez.saveImodeFlash", imode.getFlash());
		if (imode.getDecomail() != null)
			template.insert("livez.saveImodeDecomail", imode.getDecomail());

		if (imode.getFrames() != null) {
			Iterator<ImodeFrame> iterator = imode.getFrames().iterator();
			while (iterator.hasNext()) {
				ImodeFrame frame = iterator.next();
				template.insert("livez.saveImodeFrame", frame);
			}
		}
	}

	/*
	 * @see jp.sourceforge.livez.dao.ImodeDAO#update(jp.sourceforge.livez.dao.Imode, java.lang.String)
	 */
	public void update(final Imode imode, final String name) throws DataAccessException {
		delete(name);
		save(imode);
	}

	/*
	 * @see jp.sourceforge.livez.dao.ImodeDAO#delete(java.lang.String)
	 */
	public void delete(final String name) throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		template.update("livez.deleteImode", name);
	}

}
