/*
 * Copyright (C) 2005-2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.dao.ibatis;

import java.util.List;

import org.springframework.dao.DataAccessException;
import org.springframework.orm.ibatis.SqlMapClientTemplate;
import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;

import jp.sourceforge.livez.dao.Vodafone;

/**
 * VodafoneDAO  iBATIS ŎNXłB
 * 
 * @author V _
 */
public final class VodafoneDaoImpl extends SqlMapClientDaoSupport implements jp.sourceforge.livez.dao.VodafoneDAO {

	/**
	 * ftHgRXgN^łB
	 */
	public VodafoneDaoImpl() {}

	/*
	 * @see jp.sourceforge.livez.dao.VodafoneDAO#loadAll()
	 */
	@SuppressWarnings("unchecked")
	public List<Vodafone> loadAll() throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		return template.queryForList("livez.listVodafone", null);
	}

	/*
	 * @see jp.sourceforge.livez.dao.VodafoneDAO#load(java.lang.String)
	 */
	public Vodafone load(final String name) throws DataAccessException {
		return (Vodafone) getSqlMapClientTemplate().queryForObject("livez.getVodafone", name);
	}

	/*
	 * @see jp.sourceforge.livez.dao.VodafoneDAO#save(jp.sourceforge.livez.dao.Vodafone)
	 */
	public void save(final Vodafone vodafone) throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		template.insert("livez.saveVodafone", vodafone);
	}

	/*
	 * @see jp.sourceforge.livez.dao.VodafoneDAO#update(jp.sourceforge.livez.dao.Vodafone, java.lang.String)
	 */
	public void update(final Vodafone vodafone, final String name) throws DataAccessException {
		delete(name);
		save(vodafone);
	}

	/*
	 * @see jp.sourceforge.livez.dao.VodafoneDAO#delete(java.lang.String)
	 */
	public void delete(final String name) throws DataAccessException {
		SqlMapClientTemplate template = getSqlMapClientTemplate();
		template.update("livez.deleteVodafone", name);
	}

}
