/*
 * Copyright (C) 2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.pages;

import java.util.Stack;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

/**
 * @author V _
 */
final class BlockLevelHandler extends AbstractPageHandler {

	/*
	 * @see org.xml.sax.ContentHandler#startDocument()
	 */
	@Override
	public void startDocument() /* throws SAXException */ {
	}

	/*
	 * @see org.xml.sax.ContentHandler#endDocument()
	 */
	@Override
	public void endDocument() /* throws SAXException */ {
	}

	@Override
	public void doStart(
		final String uri,
		final String localName,
		final String qName,
		final Attributes attributes)
		throws SAXException {

		super.doStart(uri, localName, qName, attributes);
	}

	@Override
	public void doEnd(
		final String uri,
		final String localName,
		final String qName)
		throws SAXException {

		super.doEnd(uri, localName, qName);
	}

	private static boolean isLayoutBlockLevelElement(final String name) {
		return "center".equalsIgnoreCase(name)
			|| "div".equalsIgnoreCase(name)
			;
	}

	private static boolean isBlockLevelElement(final String name) {
		return "p".equalsIgnoreCase(name)
			|| "h1".equalsIgnoreCase(name)
			|| "h2".equalsIgnoreCase(name)
			|| "h3".equalsIgnoreCase(name)
			|| "h4".equalsIgnoreCase(name)
			|| "h5".equalsIgnoreCase(name)
			|| "h6".equalsIgnoreCase(name)
			|| "ul".equalsIgnoreCase(name)
			|| "ol".equalsIgnoreCase(name)
			|| "dir".equalsIgnoreCase(name)
			|| "menu".equalsIgnoreCase(name)
			|| "pre".equalsIgnoreCase(name)
			|| "dl".equalsIgnoreCase(name)
			|| "div".equalsIgnoreCase(name)
			|| "center".equalsIgnoreCase(name)
			|| "noscript".equalsIgnoreCase(name)
			|| "noframes".equalsIgnoreCase(name)
			|| "blockquote".equalsIgnoreCase(name)
			|| "form".equalsIgnoreCase(name)
			|| "isindex".equalsIgnoreCase(name)
			|| "hr".equalsIgnoreCase(name)
			|| "table".equalsIgnoreCase(name)
			|| "fildeset".equalsIgnoreCase(name)
			|| "address".equalsIgnoreCase(name)
			|| "multicol".equalsIgnoreCase(name)
			;
	}

}
