/*
 * Copyright (C) 2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.pages;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.io.IOUtils;
import org.apache.xerces.xni.parser.XMLDocumentFilter;
import org.cyberneko.html.filters.ElementRemover;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * w肳ꂽ\[X HTML Tv\zNXłB
 * 
 * @author V _
 */
final class HTMLAnalyzer {

	private static final ElementRemover remover = new ElementRemover();

	static {
		remover.acceptElement("base",		new String[] { "href" });
		remover.acceptElement("title",		null);
		remover.acceptElement("body",		null);
		remover.acceptElement("frameset",	null);
	}

	/**
	 * CX^XłȂ܂B
	 */
	private HTMLAnalyzer() {}

	public static HTMLOverview analyze(final byte[] bytes, final String encoding) throws IOException, SAXException {
		ByteArrayInputStream in = new ByteArrayInputStream(bytes);
		try {
			return analyze(in, encoding);
		} finally {
			IOUtils.closeQuietly(in);
		}
	}

	private static HTMLOverview analyze(final InputStream in, final String encoding) throws IOException, SAXException {
		InputSource input = new InputSource(in);

		if (encoding != null)
			input.setEncoding(encoding);

		return analyze(input);
	}

	private static HTMLOverview analyze(final InputSource input) throws IOException, SAXException {
		HTMLAnalyzerHandler handler = new HTMLAnalyzerHandler();
		HTMLParser.parse(input, handler, new XMLDocumentFilter[] { remover });
		return handler.getOverview();
	}

}
