/*
 * Copyright (C) 2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.pages;

import java.net.URI;
import java.net.URISyntaxException;

import org.apache.commons.lang.StringUtils;
import org.xml.sax.Attributes;
import org.xml.sax.ext.DefaultHandler2;

/**
 * y[W̃wb_𒊏onhNXłB
 * 
 * @author V _
 */
final class HTMLAnalyzerHandler extends DefaultHandler2 {

	private HTMLOverview overview = new HTMLOverview();

	public HTMLOverview getOverview() {
		return overview;
	}

	/**
	 * ^CgvfQƂǂێ܂B
	 */
	private boolean seenTitle;

	/*
	 * @see org.xml.sax.ContentHandler#startDocument()
	 */
	@Override
	public void startDocument() /* throws SAXException */ {
		overview = new HTMLOverview();
		seenTitle = false;
	}

	/*
	 * @see org.xml.sax.ContentHandler#startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)
	 */
	@Override
	public void startElement(
		final String uri,
		final String localName,
		final String qName,
		final Attributes attributes)
		/* throws SAXException */ {

		if (qName.equalsIgnoreCase("title") && StringUtils.isEmpty(overview.getTitle()))
			seenTitle = true;
		else if (qName.equalsIgnoreCase("base") && overview.getBaseURI() == null)
			try {
				overview.setBaseURI(new URI(attributes.getValue("href")));
			} catch (URISyntaxException e) {}	// 
		else if (qName.equalsIgnoreCase("body") && overview.getType() == null)
			overview.setType(HTMLType.CONTENTS);
		else if (qName.equalsIgnoreCase("frameset") && overview.getType() == null)
			overview.setType(HTMLType.FRAMESET);
	}

	/*
	 * @see org.xml.sax.ContentHandler#characters(char[], int, int)
	 */
	@Override
	public void characters(
		final char[] ch,
		final int start,
		final int length)
		/* throws SAXException */ {

		if (seenTitle) {
			overview.setTitle(new String(ch, start, length));
			seenTitle = false;
		}
	}

}
