/*
 * Copyright (C) 2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.pages;

import java.net.URI;

import org.apache.commons.lang.StringUtils;

import jp.sourceforge.livez.lang.StringEscapeUtils;

/**
 * HTML ̊Tv񋟂܂B
 * 
 * @author V _
 */
final class HTMLOverview {

	/**
	 * ftHgRXgN^łB
	 */
	public HTMLOverview() {
		this.title = null;
		this.baseURI = null;
		this.type = null;
	}

	/**
	 * RXgN^łB
	 * 
	 * @param title ̃^Cg
	 * @param baseURI  URI
	 * @param pageType y[W̎
	 */
	public HTMLOverview(final String title, final URI baseURI, final HTMLType pageType) {
		this.title = title;
		this.baseURI = baseURI;
		this.type = pageType;
	}

	/**
	 * ̃^Cgێ܂B
	 */
	private String title;

	/**
	 * ̃^CgԂ܂B^Cg݂Ȃꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return ̃^CgB܂ <code>null</code>
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * ̃^Cgݒ肵܂B
	 * 
	 * @param title ̃^Cg
	 */
	void setTitle(final String title) {
		this.title = title;
	}

	/**
	 *  URI ׂ̊ URI ێ܂B
	 */
	private URI baseURI;

	/**
	 *  URI ׂ̊ URI Ԃ܂B URI ݂Ȃꍇ <code>null</code> Ԃ܂B
	 * 
	 * @return  URI ׂ̊ URIB܂ <code>null</code>
	 */
	public URI getBaseURI() {
		return baseURI;
	}

	/**
	 *  URI ׂ̊ URI ݒ肵܂B
	 * 
	 * @param baseURI  URI
	 */
	void setBaseURI(final URI baseURI) {
		this.baseURI = baseURI;
	}

	/**
	 * HTML ̎ނێ܂B
	 */
	private HTMLType type;

	/**
	 * HTML ̎ނԂ܂B
	 * 
	 * @return HTML ̎
	 */
	public HTMLType getType() {
		return type;
	}

	/**
	 * HTML ̎ނݒ肵܂B
	 * 
	 * @param type HTML ̎
	 */
	void setType(final HTMLType type) {
		this.type = type;
	}

	public String render() {
		StringBuilder sb = new StringBuilder(50 + 256 + 256);

		sb.append("<head>");

		if (baseURI != null) {
			sb.append("<base href=\"");
			sb.append(baseURI.toString());
			sb.append("\">");
		}

		if (StringUtils.isNotEmpty(title)) {
			sb.append("<title>");
			sb.append(StringEscapeUtils.escapeHtml(title));
			sb.append("</title>");
		}

		sb.append("</head>");

		return sb.toString();
	}

}
