/*
 * Copyright (C) 2006 Kouji Sugisawa. All rights reserved.
 */

package jp.sourceforge.livez.pages;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import org.apache.commons.io.IOUtils;
import org.apache.xerces.xni.parser.XMLDocumentFilter;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import jp.sourceforge.livez.util.URLUtils;

/**
 * 
 * @author V _
 * @deprecated 
 */
public final class PageConverter {

	public static String toMobile(final File file, final String encoding)
		throws MalformedURLException, IOException, SAXException {

		return toMobile(file.toURI().toURL(), encoding);
	}

	public static String toMobile(final URL url, final String encoding)
		throws IOException, SAXException {

		// \[X֐ڑ܂B
		URLConnection conn = URLUtils.getURLConnection(url);
		conn.connect();

		byte[] bytes = URLUtils.getByteArray(conn);
		final String charset = URLUtils.getCharSet(conn);

		// y[W̃wb_擾܂B
		HTMLOverview overview = HTMLAnalyzer.analyze(bytes, charset);

		// y[W̃RecȂꍇ̖͋{vfݒ肵𔲂܂B
		if (overview.getType() == null)
			return "<html><body></body></html>";

		StringBuilder page = new StringBuilder(1024 * 2);

		page.append("<html>");
		page.append(overview.render());

		// y[Wt[̏ꍇAet[̓eǍŃtbg܂B
		if (overview.getType() == HTMLType.FRAMESET)
			bytes = FrameSetConverter.convert(bytes, charset, url, overview).getBytes(encoding);

		// ubNxvfe[uvfȂǂtbg܂B
		page.append(convert(bytes, encoding));

		page.append("</html>");

		return page.toString();
	}

	private static String convert(final byte[] bytes, final String encoding) throws IOException, SAXException {
		InputStream in = new ByteArrayInputStream(bytes);
		try {
			return convert(in, encoding);
		} finally {
			IOUtils.closeQuietly(in);
		}
	}

	private static String convert(final InputStream in, final String encoding) throws IOException, SAXException {
		InputSource input = new InputSource(in);

		if (encoding != null)
			input.setEncoding(encoding);

		return convert(input);
	}

	private static String convert(final InputSource input) throws IOException, SAXException {
		BlockLevelHandler handler = new BlockLevelHandler();
		HTMLParser.parse(input, handler, new XMLDocumentFilter[] { new ElementFilter() });
		return handler.getPage();
	}

}
